## org.apache.http.client
Interface RequestDirector

All Known Implementing Classes:
  DefaultRequestDirector

    public interface RequestDirector

A client-side request director. The director decides which steps are necessary to execute a request. It establishes connections and optionally processes redirects and authentication challenges. The director may therefore generate and send a sequence of requests in order to execute one initial request.

Since:
  4.0

Method Summary
`HttpResponse` `execute(HttpHost target, HttpRequest request, HttpContext context)` Executes a request.

Method Detail

### execute

    HttpResponse execute(HttpHost target,
                         HttpRequest request,
                         HttpContext context)
                         throws HttpException,
                                IOException

  Executes a request.
  Note: For the time being, a new director is instantiated for each request. This is the same behavior as for `HttpMethodDirector` in HttpClient 3.

  Parameters:
    `target` - the target host for the request. Implementations may accept `null` if they can still determine a route, for example to a default target or by inspecting the request.
    `request` - the request to execute
    `context` - the context for executing the request
  Returns:
    the final response to the request. This is never an intermediate response with status code 1xx.
  Throws:
    `HttpException` - in case of a problem
    `IOException` - in case of an IO problem or if the connection was aborted

Copyright © 1999-2012 The Apache Software Foundation. All Rights Reserved.